



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>argparse - 命令行选项与参数解析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">argparse - 命令行选项与参数解析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 03:10:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>argparse模块作为optparse的一个替代被添加到Python2.7。argparse的实现支持一些不易于添加到optparse以及要求向后不兼容API变化的特性，因此以一个新模块添加到标准库。</p>
<h3>与optparse相比较</h3>
<p>argparse的API类似于optparse，甚至在很多情况下通过更新所使用的类名和方法名，使用argparse作为一个简单的替代。然而，有些地方在添加新特性时不能保持直接兼容性。</p>
<p>你必须视情况决定是否升级已有的程序。如果你已编写了额外的代码以弥补optparse的局限，也许你想升级程序以减少你需要维护的代码量。若argparse在所有部署平台上都可用，那么新的程序应尽可能使用argparse。</p>
<h3>设置一个解析器</h3>
<p>使用argparse的第一步就是创建一个解析器对象，并告诉它将会有些什么参数。那么当你的程序运行时，该解析器就可以用于处理命令行参数。</p>
<p>解析器类是&nbsp;<strong>ArgumentParser</strong>&nbsp;。构造方法接收几个参数来设置用于程序帮助文本的描述信息以及其他全局的行为或设置。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse<br />
parser = argparse.ArgumentParser(description='This is a PyMOTW sample program')<br />
</code></pre>
</div>
<h3>定义参数</h3>
<p>argparse是一个全面的参数处理库。参数可以触发不同的动作，动作由&nbsp;<strong>add_argument()</strong>&nbsp;方法的&nbsp;<em>action</em>&nbsp;参数指定。 支持的动作包括保存参数（逐个地，或者作为列表的一部分），当解析到某参数时保存一个常量值（包括对布尔开关真/假值的特殊处理），统计某个参数出现的次数，以及调用一个回调函数。</p>
<p>默认的动作是保存参数值。在这种情况下，如果提供一个类型，那么在存储之前会先把该参数值转换成该类型。如果提供&nbsp;<em>dest</em>&nbsp;参数，参数值就保存为命令行参数解析时返回的命名空间对象中名为该&nbsp;<em>dest</em>&nbsp;参数值的一个属性。</p>
<h3>解析一个命令行</h3>
<p>定义了所有参数之后，你就可以给&nbsp;<strong>parse_args()</strong>&nbsp;传递一组参数字符串来解析命令行。默认情况下，参数是从&nbsp;<code>sys.argv[1:]</code>&nbsp;中获取，但你也可以传递自己的参数列表。选项是使用GNU/POSIX语法来处理的，所以在序列中选项和参数值可以混合。</p>
<p><strong>parse_args()</strong>&nbsp;的返回值是一个<strong>命名空间</strong>，包含传递给命令的参数。该对象将参数保存其属性，因此如果你的参数&nbsp;<code>dest</code>&nbsp;是&nbsp;<code>"myoption"</code>，那么你就可以<code>args.myoption</code>&nbsp;来访问该值。</p>
<h3>简单示例</h3>
<p>以下简单示例带有3个不同的选项：一个布尔选项（<code>-a</code>），一个简单的字符串选项（<code>-b</code>），以及一个整数选项（<code>-c</code>）。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser(description='Short sample app')

parser.add_argument('-a', action="store_true", default=False)<br />
parser.add_argument('-b', action="store", dest="b")<br />
parser.add_argument('-c', action="store", dest="c", type=int)

print parser.parse_args(['-a', '-bval', '-c', '3'])<br />
</code></pre>
</div>
<p>有几种方式传递值给单字符选项。以上例子使用了两种不同的形式，<code>-bval</code>和<code>-c val</code>。</p>
<div>
<pre class="prettyprint linenums"><code>$ python argparse_short.py<br />
Namespace(a=True, b='val', c=3)<br />
</code></pre>
</div>
<p>在输出中与<code>'c'</code>关联的值是一个整数，因为程序告诉<strong>ArgumentParser</strong>在保存之前先转换该参数。</p>
<p>“长”选项名字，即选项的名字多于一个字符，以相同的方式进行处理。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser(description='Example with long option names')

parser.add_argument('--noarg', action="store_true", default=False)<br />
parser.add_argument('--witharg', action="store", dest="witharg")<br />
parser.add_argument('--witharg2', action="store", dest="witharg2", type=int)

print parser.parse_args(['--noarg', '--witharg', 'val', '--withargs=3'])<br />
</code></pre>
</div>
<p>结果也类似：</p>
<div>
<pre class="prettyprint linenums"><code>$ python argparse_long.py<br />
Namespace(noarg=True, witharg='val', witharg2=3)<br />
</code></pre>
</div>
<p>argparse区别于optparse的一个地方是对非选项参数值的处理。optparse只进行选项解析，而argparse是一个全面的命令行参数解析工具，也处理非选项参数。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser(description='Example with non-optional arguments')

parser.add_argument('count', action="store", type=int)<br />
parser.add_argument('units', action="store")

print parser.parse_args()<br />
</code></pre>
</div>
<p>在这个例子中，“count”参数是一个整数，“units”参数存储为一个字符串。其中任意一个参数若没有在命令行中提供，或给定的值不能被转换为正确的类型，就会报告一个错误。</p>
<div>
<pre class="prettyprint linenums"><code>$ python argparse_arguments.py 3 inches

Namespace(count=3, units='inches')

$ python argparse_arguments.py some inches

usage: argparse_arguments.py [-h] count units<br />
argparse_arguments.py: error: argument count: invalid int value: 'some'

$ python argparse_arguments.py

usage: argparse_arguments.py [-h] count units<br />
argparse_arguments.py: error: too few arguments<br />
</code></pre>
</div>
<h3>参数动作</h3>
<p>argparse内置6种动作可以在解析到一个参数时进行触发：</p>
<p><code>store</code>&nbsp;保存参数值，可能会先将参数值转换成另一个数据类型。若没有显式指定动作，则默认为该动作。</p>
<p><code>store_const</code>&nbsp;保存一个被定义为参数规格一部分的值，而不是一个来自参数解析而来的值。这通常用于实现非布尔值的命令行标记。</p>
<p><code>store_ture</code>/<code>store_false</code>&nbsp;保存相应的布尔值。这两个动作被用于实现布尔开关。</p>
<p><code>append</code>&nbsp;将值保存到一个列表中。若参数重复出现，则保存多个值。</p>
<p><code>append_const</code>&nbsp;将一个定义在参数规格中的值保存到一个列表中。</p>
<p><code>version</code>&nbsp;打印关于程序的版本信息，然后退出</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser()

parser.add_argument('-s', action='store', dest='simple_value',<br />
        help='Store a simple value')

parser.add_argument('-c', action='store_const', dest='constant_value',<br />
        const='value-to-store',<br />
        help='Store a constant value')

parser.add_argument('-t', action='store_true', default=False,<br />
        dest='boolean_switch',<br />
        help='Set a switch to true')<br />
parser.add_argument('-f', action='store_false', default=False,<br />
        dest='boolean_switch',<br />
        help='Set a switch to false')

parser.add_argument('-a', action='append', dest='collection',<br />
        default=[],<br />
        help='Add repeated values to a list')

parser.add_argument('-A', action='append_const', dest='const_collection',<br />
        const='value-1-to-append',<br />
        default=[],<br />
        help='Add different values to list')<br />
parser.add_argument('-B', action='append_const', dest='const_collection',<br />
        const='value-2-to-append',<br />
        help='Add different values to list')

parser.add_argument('--version', action='version', version='%(prog)s 1.0')

results = parser.parse_args()<br />
print 'simple_value     =', results.simple_value<br />
print 'constant_value   =', results.constant_value<br />
print 'boolean_switch   =', results.boolean_switch<br />
print 'collection       =', results.collection<br />
print 'const_collection =', results.const_collection<br />
</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>$ python argparse_action.py -h

usage: argparse_action.py [-h] [-s SIMPLE_VALUE] [-c] [-t] [-f]<br />
                          [-a COLLECTION] [-A] [-B] [--version]

optional arguments:<br />
  -h, --help       show this help message and exit<br />
  -s SIMPLE_VALUE  Store a simple value<br />
  -c               Store a constant value<br />
  -t               Set a switch to true<br />
  -f               Set a switch to false<br />
  -a COLLECTION    Add repeated values to a list<br />
  -A               Add different values to list<br />
  -B               Add different values to list<br />
  --version        show program's version number and exit

$ python argparse_action.py -s value

simple_value     = value<br />
constant_value   = None<br />
boolean_switch   = False<br />
collection       = []<br />
const_collection = []

$ python argparse_action.py -c

simple_value     = None<br />
constant_value   = value-to-store<br />
boolean_switch   = False<br />
collection       = []<br />
const_collection = []

$ python argparse_action.py -t

simple_value     = None<br />
constant_value   = None<br />
boolean_switch   = True<br />
collection       = []<br />
const_collection = []

$ python argparse_action.py -f

simple_value     = None<br />
constant_value   = None<br />
boolean_switch   = False<br />
collection       = []<br />
const_collection = []

$ python argparse_action.py -a one -a two -a three

simple_value     = None<br />
constant_value   = None<br />
boolean_switch   = False<br />
collection       = ['one', 'two', 'three']<br />
const_collection = []

$ python argparse_action.py -B -A

simple_value     = None<br />
constant_value   = None<br />
boolean_switch   = False<br />
collection       = []<br />
const_collection = ['value-2-to-append', 'value-1-to-append']

$ python argparse_action.py --version

argparse_action.py 1.0<br />
</code></pre>
</div>
<h3>选项前缀</h3>
<p>argparse选项的默认语法是基于Unix约定的，使用一个“-”前缀来表示命令行开关。argparse支持其他前缀，因此你可以使得你的程序遵照本地平台的默认语法（例如，在Window上使用“/”）或者遵循不同的约定。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser(description='Change the option prefix charaters',<br />
        prefix_chars='-+/')

parser.add_argument('-a', action="store_false", default=None,<br />
        help='Turn A off')

parser.add_argument('+a', action="store_true", default=None,<br />
        help='Turn A on')

parser.add_argument('//noarg', '++noarg', action="store_true", default=False)

print parser.parse_args()<br />
</code></pre>
</div>
<p>将<strong>ArgumentParser</strong>&nbsp;方法的<em>prefix_chars</em>&nbsp;参数设置为一个字符串，该字符串包含所有允许用来表示选项的字符。需要理解的是虽然<em>prefix_chars</em>包含允许用于开关的字符，但单个参数定义只能使用一种给定的开关语法。这让你可以对使用不同前缀的选项是否是别名（比如独立于平台的命令行语法的情况）或替代选择（例如，使用“+”表明打开一个开发，“-”则为关闭一个开关）进行显式地控制。在上述例子中，<code>+a</code>和<code>-a</code>是不同的参数，<code>//noarg</code>&nbsp;也可以&nbsp;<code>++noarg</code>&nbsp;提供，但不是&nbsp;<code>--noarg</code>。</p>
<div>
<pre class="prettyprint linenums"><code>$ python argparse_prefix_chars.py -h

usage: argparse_prefix_chars.py [-h] [-a] [+a] [//noarg]

Change the option prefix characters

optional arguments<br />
    -h, --help  show this help message and exit<br />
    -a  Turn A off<br />
    +a  Turn A on<br />
    //noarg,++noarg

$ python argparse_prefix_chars.py +a

Namespace(a=True, noarg=False)

$ python argparse_prefix_chars.py -a

Namespace(a=False, noarg=False)

$ python argparse_prefix_chars.py //noarg

Namespace(a=None, noarg=True)

$ python argparse_prefix_chars.py ++noarg

Namespace(a=None, noarg=True)

$ python argparse_prefix_chars.py --noarg

usage: argparse_prefix_chars.py [-h] [-a] [+a] [//noarg]<br />
argparse_prefix_chars.py: error: unrecognized arguments: --noarg<br />
</code></pre>
</div>
<h3>参数来源</h3>
<p>目前为止所见的例子中，提供给解析器的参数列表来自于显式传递的一个列表，或隐式地从sys.argv获取的。显式传递列表在你使用argparse来处理类命令行但并不是来自命令行（比如来自一个配置文件）的指令之时比较有用。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse<br />
from ConfigParser import ConfigParser<br />
import shlex

parser = argparse./span&gt;ArgumentParser(description='Short sample app')

parser.add_argument('-a', action="store_true", default=False)<br />
parser.add_argument('-b', action="store", dest="b")<br />
parser.add_argument('-c', action="store", dest="c", type=int)

config = ConfigParser()<br />
config.read('argparse_witH_shlex.ini')<br />
config_value = config.get('cli', 'options')<br />
print 'Config: ', config_value

argument_list = shlex.split(config_value)<br />
print 'Arg List:', argument_list

print 'Results:', parser.parse_args(argument_list)<br />
</code></pre>
</div>
<p>shlex使得切分存储在配置文件中的字符串非常容易。</p>
<div>
<pre class="prettyprint linenums"><code>$ python argparse_with_shlex.py

Config: -a -b 2<br />
Arg List: ['-a', '-b', '2']<br />
Results: Namespace(a=True, b='2', c=None)<br />
</code></pre>
</div>
<p>另一种自己处理配置文件的方法是使用<em>fromfile_prefix_chars</em>指定一个包含一组要待处理参数的输入文件来告诉argparse怎样识别参数。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse<br />
from ConfigParser import ConfigParser<br />
import shlex

parser = argparse.ArgumentParser(description='Short sample app',<br />
        fromfile_prefix_chars='@'<br />
        )

parser.add_argument('-a', action="store_true", default=False)<br />
parser.add_argument('-b', action="store", dest="b")<br />
parser.add_argument('-c', action="store", dest="c", type=int)

print parser.parse_args(['@argparse_fromfile_prefix_chars.txt'])<br />
</code></pre>
</div>
<p>该示例代码在找到一个以<em>@</em>为前缀的参数时即停止往下读取，然后从以该参数命名的文件中查找更多的参数。例如，输入文件<code>argparse_fromfile_prefix_chars.txt</code>包含一系列参数，一行一个：</p>
<pre class="prettyprint linenums"><code>-a<br />
-b<br />
2</code></pre>
<p>那么处理该文件产生的输出为：</p>
<pre class="prettyprint linenums"><code>$ python argparse_fromfile_prefix_chars.py

Namespace(a=True, b='2', c=None)</code></pre>
<h3>自动生成选项</h3>
<p>经过配置argparse会自动添加选项用来生成帮助信息以及为你的应用程序显示版本信息。</p>
<p><strong>ArgumentParser</strong>的参数<em>add_help</em>&nbsp;控制帮助信息相关的选项。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser(add_help=True)

parser.add_argument('-a', action="store_true", default=False)<br />
parser.add_argument('-b', action="store", dest="b")<br />
parser.add_argument('-c', action="store", dest="c", type=int)

print parser.parse_args()<br />
</code></pre>
</div>
<p>帮助选项（-h和–help）默认是添加的，但可以通过将<em>add_help</em>设置为false来禁用。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser(add_help=False)

parser.add_argument('-a', action="store_true", default=False)<br />
parser.add_argument('-b', action="store", dest="b")<br />
parser.add_argument('-c', action="store", dest="c", type=int)

print parser.parse_args()<br />
</code></pre>
</div>
<p>虽然<code>-h</code>和<code>--help</code>是事实上的请求帮助的标准选项名称，但一些应用或argparse的使用要么不需要提供帮助要么需要将这两个选项名称用于其他目标。</p>
<pre class="prettyprint linenums"><code>$ python argparse_with_help.py -h

usage: argparse_with_help.py [-h] [-a] [-b B] [-c C]

optional arguments:<br />
    -h, --help  show this help message and exit<br />
    -a<br />
    -b B<br />
    -c C

$ python argparse_without_help.py -h

usage: argparse_without_help.py [-a] [-b B] [-c C]<br />
argparse_without_help.py: error: unrecognized arguments: -h</code></pre>
<p>当在<strong>ArgumentParser</strong>构造方法设置<em>版本</em>后，就会添加版本选项（<code>-v</code>和<code>--version</code>）。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser(version='1.0')

parser.add_argument('-a', action="store_true", default=False)<br />
parser.add_argument('-b', action="store", dest="b")<br />
parser.add_argument('-c', action="store", dest="c", type=int)

print parser.parse_args()

print 'This is not printed'<br />
</code></pre>
</div>
<p>两种形式的选项爱那个都会打印程序的版本字符串，然后立即退出程序。</p>
<pre class="prettyprint linenums"><code>$ python argparse_with_version.py -h

usage: argparse_with_version.py [-h] [-v] [-a] [-b B] [-c C]

optional arguments:<br />
    -h, --help  show this help message and exit<br />
    -v, --version   show program's version number and exit<br />
    -a<br />
    -b B<br />
    -c C

$ python argparse_with_version.py -v

1.0</code></pre>
<h3>解析器组</h3>
<p>argparse包含若干特性用于组织你的参数解析器，使得实现更为简单，也能提高输出帮助信息的可用性。</p>
<p><strong>共享解析器规则</strong></p>
<p>我们常常需要实现一套命令行程序，这些程序都带一组参数，只是在某些方面有特殊化。例如，如果所有程序都需要在用户进行任何实际的操作之前对用户进行认证，那么它们就都需要支持<code>--user</code>和<code>--password</code>选项。你可以共享的选项来定义一个“父母”解析器，然后令单个程序的解析器从该“父母”解析器继承共享选项，这样就不必显式为每个<strong>ArgumentParser</strong>添加共享选项。</p>
<p>第一步是以共享的参数定义建立“父母”解析器。由于“父母”解析器的后代使用者会添加相同的帮助选项，从而会引发一个异常，所以在基础解析器中我们关闭自动帮助选项生成。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser(add_help=False)

parser.add_argument('--user', action="store")<br />
parser.add_argument('--password', action="store")<br />
</code></pre>
</div>
<p>接下来，以<em>父母解析器</em>集创建另一个解析器：</p>
<div>
<pre class="prettyprint linenums"><code>import argparse<br />
import argparse_parent_base

parser = argparse.ArgumentParser(parents=[argparse_parent_base.parser])

parser.add_argument('--local-arg', action="store_true", default=False)

print parser.parse_args()<br />
</code></pre>
</div>
<p>得到的程序带有三个选项：</p>
<pre class="prettyprint linenums"><code>$ python argparse_uses_parent.py -h

usage: argparse_uses_parent.py [-h] [--user USER] [--password PASSWORD]<br />
                           [--local-arg]

optional arguments:<br />
    -h, --help           show this help message and exit<br />
    --user USER<br />
    --password PASSWORD<br />
    --local-arg</code></pre>
<p><strong>冲突的选项</strong></p>
<p>前一个例子指出以相同的参数名字为一个解析器添加两个参数处理器会引发一个异常。可以通过传递一个<em>conflict_handler</em>来改变冲突消除行为。argparse有两个内置的冲突处理器<code>error</code>（默认）和<code>resolve</code>，<code>resolve</code>会基于冲突选项的添加顺序来选择一个参数处理器。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser(conflict_handler='resolve')

parser.add_argument('-a', action="store")<br />
parser.add_argument('-b', action="store", help="Short alone")<br />
parser.add_argument('--long-b', '-b', action="store", help="Long and short together")

print parser.parse_args(['-h'])<br />
</code></pre>
</div>
<p>由于最后一个处理器所给定的参数名已被使用，那么本例中独立选项<code>-b</code>将被<code>--long-b</code>的别名所覆盖。</p>
<pre class="prettyprint linenums"><code>$ python argparse_conflict_handler_resolve.py

usage: argparse_conflict_handler_resolve.py [-h] [-a A] [--long-b LONG_B]

optional arguments:<br />
    -h, --help  show this help message and exit<br />
    -a A<br />
    --long-b LONG_B, -b LONG_B<br />
            Long and short together</code></pre>
<p>切换<strong>add_argument()</strong>的调用顺序就可以启用独立的选项：</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser(conflict_handler='resolve')

parser.add_argument('-a', action="store")<br />
parser.add_argument('--long-b', '-b', action="store", help='Long and short together')<br />
parser.add_argument('-b', action="store", help='Short alone')

print parser.parse_args([-h])<br />
</code></pre>
</div>
<p>现在两个选项可以一起使用了。</p>
<pre class="prettyprint linenums"><code>$ python argparse_conflict_handler_resolve2.py

usage: argparse_conflict_handler_resolve2.py [-h] [-a A] [--long-b LONG_B] [-b B]

optional arguments:<br />
    -h, --help  show this help message and exit<br />
    -a A<br />
    --long-b LONG_B Long and short together<br />
    -b B    Short alone</code></pre>
<p><strong>参数群组</strong></p>
<p>argparse能将参数定义组合成“群组”。默认情况下是使用两个群组，一个是选项的群组，另一个是必须的与位置相关的参数群组。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser(description='Short sample app')

parser.add_argument('--optional', action="store_true", default=False)<br />
parser.add_argument('positional', action="store")

print parser.parse_args()<br />
</code></pre>
</div>
<p>群组在输出的帮助信息中显示为分开的“与位置相关的参数”和“可选参数”两个部分：</p>
<pre class="prettyprint linenums"><code>$ python argparse_default_grouping.py

usage: argparse_default_grouping.py [-h] [--optional] positional

Short sample app

positional arguments:<br />
    positional

optional arguments:<br />
    -h, --help  show this help message and exit<br />
    --optional</code></pre>
<p>你可以调整群组来提高帮助信息中群组的逻辑性，这样相关选项或值能记录在一起。可以使用自定义群组来重写之前的共享选项的示例，如此在帮助信息中身份认证的选项就可以显示在一起。</p>
<p>在基础解析器中使用<strong>add_argument_group()</strong>来创建一个“身份认证”群组，然后逐个添加身份认证相关的选项到该群组。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparser.ArgumentParser(add_help=False)

group = parser.add_argument_group('authentication')

group.add_argument('--user', action="store")<br />
group.add_argument('--password', action="store")<br />
</code></pre>
</div>
<p>与之前一样，程序使用基于群组的父母解析器列表作为<em>parents</em>的值。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse<br />
import argparse_parent_with_group

parser = argparse.ArgumentParser(parents=[argparse_parent_with_group.parser])

parser.add_argument('--local-arg', action="store_true", default=False)

print parser.parse_args()<br />
</code></pre>
</div>
<p>现在输出的帮助信息一起显示身份认证选项。</p>
<pre class="prettyprint linenums"><code>$ python argparse_uses_parent_with_group.py -h

usage: argparse_uses_parent_with_group.py [-h] [--user USER] [--password PASSWORD] [--local-arg]

optional arguments:<br />
    -h, --help  show this message and exit<br />
    --local-arg

authentication:<br />
    --user USER<br />
    --password PASSWORD</code></pre>
<p><strong>互斥选项</strong></p>
<p>定义互斥的选项是选项分组特性的一个特例，使用<strong>add_mutually_exclusive_group()</strong>而不是<strong>add_argument_group()</strong>。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser()

group = parser.add_mutually_exclusive_group()<br />
group.add_argument('-a', action='store_true')<br />
group.add_argument('-b', action="store_true")

print parser.parse_args()<br />
</code></pre>
</div>
<p>argparse会为你强制执行互斥性，因此一次使用仅能给出该群组的选项中的一个。</p>
<pre class="prettyprint linenums"><code>$ python argparse_mutually_exclusive.py -h

usage: argparse_mutually_exclusive.py [-h] [-a | -b]

optional arguments:<br />
    -h, --help  show this help message and exit<br />
    -a<br />
    -b

$ python argparse_mutually_exclusive.py -a

Namespace(a=True, b=False)

$ python argparse_mutually_exclusive.py -b

Namespace(a=False, b=True)

$ python argparse_mutually_exclusive.py -a -b

usage: argparse_mutually_exclusive.py [-h] [-a | -b]<br />
argparse_mutually_exclusive.py: error: argument -b: not allowed with argument -a</code></pre>
<p><strong>嵌套解析器</strong></p>
<p>上述的父母解析器方式是在相关命令之间共享选项的方式之一。另一种方式是将多个命令组合进一个程序中，使用子解析器来处理命令行的每个部分。就像<code>svn</code>，<code>hg</code>，以及其他带有多个命令行行为或子命令的程序那样。</p>
<p>一个用于处理文件系统目录的程序可能会像这样定义命令用于创建、删除、以及列出一个目录的内容：</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser()

subparsers = parser.add_subparsers(help='commands')

# A list command<br />
list_parser = subparsers.add_parser('list', help='List contents')<br />
list_parser.add_argument('dirname', action='store', help='Directory to list')

# A create command<br />
create_parser = subparsers.add_parser('create', help='Create a directory')<br />
create_parser.add_argument('dirname', action='store', help='New directory to create')<br />
create_parser.add_argument('--read-only', default=False, action='store_true',<br />
        help='Set permissions to prevent writing to the directory')

# A delete command<br />
delete_parser = subparsers.add_parser('delete', help='Remove a directory')<br />
delete_parser.add_argument('dirname', action='store', help='The directory to remove')<br />
delete_parser.add_argument('--recursive', '-r', default=False, action='store_true',<br />
        help='Remove the contents of the directory, too')

print parser.parse_args()<br />
</code></pre>
</div>
<p>输出的帮助信息显示作为“命令”的命名子解析器能够在命令行中作为位置参数进行指定。</p>
<pre class="prettyprint linenums"><code>$ python argparse_subparsers.py -h

usage: argparse_subparsers.py [-h] {list, create, delete} ...

positional arguments:<br />
    {list, create, delete} commands<br />
        list    List contents<br />
        create  Create a directory<br />
        delete  Remove a directory

optional arguments:<br />
    -h, --help  show this help message and exit</code></pre>
<p>每个子解析器也有自己的帮助信息，描述那个命令的参数和选项。</p>
<pre class="prettyprint linenums"><code>$ python argparse_subparsers.py create -h

usage: argparse_subparsers.py create [-h] [--read-only] dirname

positional arguments:<br />
    dirname New directory to create

optional arguments:<br />
    -h, --help  show this help message and exit<br />
    --read-only Set permissions to prevent writing to the directory</code></pre>
<p>参数被解析后，<strong>parse_args()</strong>返回的<strong>Namespace</strong>对象仅包含与指定的命令相关的值。</p>
<pre class="prettyprint linenums"><code>$ python argparse_subparsers.py delete -r foo

Namespace(dirname='foo', recursive=True)</code></pre>
<h3>高级参数处理</h3>
<p>至今为止的示例展示了简单的布尔标识、字符串或数字参数选项、以及位置参数。对于变长参数列表、枚举类型数据、以及常量，argparse支持复杂的参数规格。</p>
<p><strong>可变形参列表</strong></p>
<p>你可以配置单个参数的定义使其能够匹配所解析的命令行的多个参数。根据需要或期望的参数个数，设置<em>nargs</em>为这些标识值之一：</p>
<pre class="prettyprint linenums"><code>值  含义<br />
N   参数的绝对个数（例如：3）<br />
?   0或1个参数<br />
*   0或所有参数<br />
+   所有，并且至少一个参数</code></pre>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser()

parser.add_argument('--three', nargs=3)<br />
parser.add_argument('--optional', nargs='?')<br />
parser.add_argument('--all', nargs='*', dest='all')<br />
parser.add_argument('--one-or-more', nargs='+')

print parser.parse_args()<br />
</code></pre>
</div>
<p>解析器强制执行参数计数指令，生成一个精确的语法图作为命令帮助文本的一部分。</p>
<pre class="prettyprint linenums"><code>$ python argparse_nargs.py -h

usage: argparse_nargs.py [-h] [--three THREE THREE THREE]<br />
                     [--optional [OPTIONAL]] [--all [ALL [ALL ...]]]<br />
                     [--one-or-more ONE_OR_MORE [ONE_OR_MORE ...]]

optional arguments:<br />
-h, --help            show this help message and exit<br />
--three THREE THREE THREE<br />
--optional [OPTIONAL]<br />
--all [ALL [ALL ...]]<br />
--one-or-more ONE_OR_MORE [ONE_OR_MORE ...]

$ python argparse_nargs.py

Namespace(all=None, one_or_more=None, optional=None, three=None)

$ python argparse_nargs.py --three

usage: argparse_nargs.py [-h] [--three THREE THREE THREE]<br />
                     [--optional [OPTIONAL]] [--all [ALL [ALL ...]]]<br />
                     [--one-or-more ONE_OR_MORE [ONE_OR_MORE ...]]<br />
argparse_nargs.py: error: argument --three: expected 3 argument(s)

$ python argparse_nargs.py --three a b c

Namespace(all=None, one_or_more=None, optional=None, three=['a', 'b', 'c'])

$ python argparse_nargs.py --optional

Namespace(all=None, one_or_more=None, optional=None, three=None)

$ python argparse_nargs.py --optional with_value

Namespace(all=None, one_or_more=None, optional='with_value', three=None)

$ python argparse_nargs.py --all with multiple values

Namespace(all=['with', 'multiple', 'values'], one_or_more=None, optional=None, three=None)

$ python argparse_nargs.py --one-or-more with_value

Namespace(all=None, one_or_more=['with_value'], optional=None, three=None)

$ python argparse_nargs.py --one-or-more with multiple values

Namespace(all=None, one_or_more=['with', 'multiple', 'values'], optional=None, three=None)

$ python argparse_nargs.py --one-or-more

usage: argparse_nargs.py [-h] [--three THREE THREE THREE]<br />
                     [--optional [OPTIONAL]] [--all [ALL [ALL ...]]]<br />
                     [--one-or-more ONE_OR_MORE [ONE_OR_MORE ...]]<br />
argparse_nargs.py: error: argument --one-or-more: expected at least one argument</code></pre>
<p><strong>参数类型</strong></p>
<p>argparse将所有参数值都看作是字符串，除非你告诉它将字符串转换成另一种数据类型。<strong>add_argument()</strong>的<em>type</em>参数以一个转换函数作为值，被<strong>ArgumentParser</strong>用来将参数值从一个字符串转换成另一种数据类型。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser()

parser.add_argument('-i', type=int)<br />
parser.add_argument('-f', type=float)<br />
parser.add_argument('--file', type=file)

try:<br />
    print parser.parse_args()<br />
except IOError, msg:<br />
    parser.error(str(msg))<br />
</code></pre>
</div>
<p>任何需要单个字符串参数的可调用对象都可以传递给<em>type</em>，包含内置类型如<strong>int()</strong>,&nbsp;<strong>float()</strong>, 以及<strong>file()</strong>。</p>
<pre class="prettyprint linenums"><code>$ python argparse_type.py -i 1

Namespace(f=None, file=None, i=1)

$ python argparse_type.py -f 3.14

Namespace(f=3.14, file=None, i=None)

$ python argparse_type.py --file argparse_type.py

Namespace(f=None, file=&lt;open file 'argparse_type.py', mode 'r' at 0x1004de270&gt;, i=None)</code></pre>
<p>如果类型转换失败，argparse会引发一个异常。<em>TypeError</em>和<em>ValueError</em>会被自动捕获，并为用户转换为一个简单的错误消息。其他异常，如下面一个例子中输入文件不存在，则其<em>IOError</em>必须由调用者来处理。</p>
<pre class="prettyprint linenums"><code>$ python argparse_type.py -i a

usage: argparse_type.py [-h] [-i I] [-f F] [--file FILE]<br />
argparse_type.py: error: argument -i: invalid int value: 'a'

$ python argparse_type.py -f 3.14.15

usage: argparse_type.py [-h] [-i I] [-f F] [--file FILE]<br />
argparse_type.py: error: argument -f: invalid float value: '3.14.15'

$ python argparse_type.py --file does_not_exist.txt

usage: argparse_type.py [-h] [-i I] [-f F] [--file FILE]<br />
argparse_type.py: error: [Errno 2] No such file or directory: 'does_not_exist.txt'</code></pre>
<p>要想将一个输入参数限制为一个预定义集中的某个值，则使用<em>choices</em>参数。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser()

parser.add_argument('--mode', choices=('read-only', 'read-write'))

print parser.parse_args()<br />
</code></pre>
</div>
<p>如果<code>--mode</code>的参数值不是所允许的值中的一个，就会产生一个错误并停止执行。</p>
<pre class="prettyprint linenums"><code>$ python argparse_choices.py -h

usage: argparse_choices.py [-h] [--mode {read-only,read-write}]

optional arguments:<br />
-h, --help            show this help message and exit<br />
--mode {read-only,read-write}

$ python argparse_choices.py --mode read-only

Namespace(mode='read-only')

$ python argparse_choices.py --mode invalid

usage: argparse_choices.py [-h] [--mode {read-only,read-write}]<br />
argparse_choices.py: error: argument --mode: invalid choice: 'invalid'<br />
(choose from 'read-only', 'read-write')</code></pre>
<p><strong>文件参数</strong></p>
<p>虽然<strong>文件</strong>对象可以单个字符串参数值来实例化，但并不允许你指定访问模式。<strong>FileType</strong>让你能够更加灵活地指定某个参数应该是个文件，包括其访问模式和缓冲区大小。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

parser = argparse.ArgumentParser()

parser.add_argument('-i', metavar='in-file', type=argparse.FileType('rt'))<br />
parser.add_argument('-o', metavar='out-file', type=argparse.FileType('wt'))

try:<br />
    results = parser.parse_args()<br />
    print 'Input file:', results.i<br />
    print 'Output file:', results.o<br />
except IOError, msg:<br />
    parser.error(str(msg))<br />
</code></pre>
</div>
<p>上例中与参数名关联的值是一个打开文件句柄。在使用完该文件后应自己负责关闭该文件。</p>
<pre class="prettyprint linenums"><code>$ python argparse_FileType.py -h

usage: argparse_FileType.py [-h] [-i in-file] [-o out-file]

optional arguments:<br />
-h, --help   show this help message and exit<br />
-i in-file<br />
-o out-file

$ python argparse_FileType.py -i argparse_FileType.py -o temporary_file.\<br />
txt

Input file: &lt;open file 'argparse_FileType.py', mode 'rt' at 0x1004de270&gt;<br />
Output file: &lt;open file 'temporary_file.txt', mode 'wt' at 0x1004de300&gt;

$ python argparse_FileType.py -i no_such_file.txt

usage: argparse_FileType.py [-h] [-i in-file] [-o out-file]<br />
argparse_FileType.py: error: argument -i: can't open 'no_such_file.txt': [Errno 2] No such file or directory: 'no_such_file.txt'</code></pre>
<p><strong>自定义动作</strong></p>
<p>除了前面描述的内置动作之外，你也可以提供一个实现了Action API的对象来自定义动作。作为<em>action</em>传递给<strong>add_argument()</strong>的对象应接受描述所定义形参的实参，并返回一个可调用对象，作为<em>parser</em>的实参来处理形参，<em>namespace</em>存放解析的结果、参数值，以及触发动作的<em>option_string</em>。</p>
<p>argparse提供了一个<strong>Action</strong>类作为要定义的新动作的基类。构造方法是处理参数定义的，所以你只要在子类中覆盖<strong><strong>call</strong>()</strong>。</p>
<div>
<pre class="prettyprint linenums"><code>import argparse

class CustomAction(argparse.Action):<br />
    def __init__(self,<br />
            option_strings,<br />
            dest,<br />
            nargs=None,<br />
            const=None,<br />
            default=None,<br />
            type=None,<br />
            choices=None,<br />
            required=False,<br />
            help=None,<br />
            metavar=None):<br />
        argparse.Action.__init__(self,<br />
                option_strings=option_strings,<br />
                dest=dest,<br />
                nargs=nargs,<br />
                const=const,<br />
                default=default,<br />
                type=type,<br />
                choices=choices,<br />
                required=required,<br />
                help=help,<br />
                metavar=metavar)<br />
        print<br />
        print 'Initializing CustomAction'<br />
        for name,value in sorted(locals().items()):<br />
            if name == 'self' or value is None:<br />
                continue<br />
            print '  %s = %r' % (name, value)<br />
        return

    def __call__(self, parser, namespace, values, option_string=None):<br />
        print<br />
        print 'Processing CustomAction for "%s"' % self.dest<br />
        print '  parser = %s' % id(parser)<br />
        print '  values = %r' % values<br />
        print '  option_string = %r' % option_string

        # Do some arbitrary processing of the input values<br />
        if isinstance(values, list):<br />
            values = [ v.upper() for v in values ]<br />
        else:<br />
            values = values.upper()<br />
        # Save the results in the namespace using the destination<br />
        # variable given to our constructor.<br />
        setattr(namespace, self.dest, values)

parser = argparse.ArgumentParser()

parser.add_argument('-a', action=CustomAction)<br />
parser.add_argument('-m', nargs='*', action=CustomAction)<br />
parser.add_argument('positional', action=CustomAction)

results = parser.parse_args(['-a', 'value', '-m' 'multi-value', 'positional-value'])<br />
print<br />
print results<br />
</code></pre>
</div>
<p><em>values</em>的类型取决于<em>nargs</em>的值。如果该参数允许多个值，则<em>values</em>会是一个列表，即使其仅包含一个列表项。</p>
<p><em>option_string</em>的值也取决于原有的参数规范。对于位置相关的、必需的参数，<em>option_string</em>始终为<strong>None</strong>。</p>
<pre class="prettyprint linenums"><code>$ python argparse_custom_action.py

Initializing CustomAction<br />
    dest = 'a'<br />
    option_strings = ['-a']<br />
    required = False

Initializing CustomAction<br />
    dest = 'm'<br />
    nargs = '*'<br />
    option_strings = ['-m']<br />
    required = False

Initializing CustomAction<br />
    dest = 'positional'<br />
    option_strings = []<br />
    required = True

Processing CustomAction for "a"<br />
    parser = 4299616464<br />
    values = 'value'<br />
    option_string = '-a'

Processing CustomAction for "m"<br />
    parser = 4299616464<br />
    values = ['multi-value']<br />
    option_string = '-m'

Processing CustomAction for "positional"<br />
    parser = 4299616464<br />
    values = 'positional-value'<br />
    option_string = None

Namespace(a='VALUE', m=['MULTI-VALUE'], positional='POSITIONAL-VALUE')</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390k1r4q.html">其实Unix很简单</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93k4rrq.html">Git创建ssh-key</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0mo6q.html">Hibernate提供的内置标识符生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq101k68.html">用word写博客</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xo1nz9.html">Andriod 字符串数组里加入字符串元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ydz35q.html">LwIP编译方法以及选项说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ddjx9.html">mono  判断系统的网络是否可用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljv2pe9.html">实例甜点 Unreal Engine 4迷你教程&lpar;4&rpar;之用C&plus;&plus;实现添加子Widget到VerticalBox中以及ClearChildren</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z33539.html">git使用教程之了解git</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj73dxq.html">spring-boot-devtools在Idea中热部署方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljy3m19.html">C&num;学习笔记-XML的读写（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwkwoj9.html">nw&period;js---创建一个点击菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj25779.html">java 中重写toString&lpar;&rpar;方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w6v40q.html">Compiler showing &apos;pi&apos; symbol on error</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2mpgx9.html">&dollar;ORACLE&lowbar;HOME&sol;rdbms&sol;demo示例安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4pyym9.html">Linux 服务器部署 PgAdmin 4 Server</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4n2rlq.html">Hadoop开发第2期---虚拟机中搭建Linux</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn11rkq.html">【题解】 bzoj3105&colon; &lbrack;cqoi2013&rsqb;新Nim游戏 （线性基&plus;贪心）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e0jlg9.html">&lbrack;转载&rsqb;使用mpvue搭建一个初始小程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveyn519.html">CentOS 7 主机名bogon解决办法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8m26ev6q.html">083 HBase的完全分布式的搭建与部署，以及多master</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gl0lvq.html">066 linux下时间的修改</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wrwrwq.html">webstorm 格式化代码及常用快捷键</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j16n009.html">Node&plus;Express&plus;MongoDB &plus; Socket&period;io搭建实时聊天应用实战教程&lpar;二&rpar;--node解析与环境搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1pvl1q.html">dns安全可视化 设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyn40mq.html">Unity3D 入门 游戏开发   Unity3D portal game development</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlldnz1q.html">10&period;23 正睿停课训练 Day7</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlld5okq.html">Codeforces&period;833B&period;The Bakery&lpar;线段树 DP&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj6d409.html">BZOJ&period;3720&period;Gty的妹子树&lpar;树分块&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1roj248.html">crm&mdash;&mdash;stark组件核心原理</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
